!***********************************************************************
! ISPACK FORTRAN SUBROUTINE LIBRARY FOR SCIENTIFIC COMPUTING
! Copyright (C) 1998--2019 Keiichi Ishioka <ishioka@gfd-dennou.org>
!
! This library is free software; you can redistribute it and/or
! modify it under the terms of the GNU Lesser General Public
! License as published by the Free Software Foundation; either
! version 2.1 of the License, or (at your option) any later version.
!
! This library is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
! Lesser General Public License for more details.
! 
! You should have received a copy of the GNU Lesser General Public
! License along with this library; if not, write to the Free Software
! Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
! 02110-1301 USA.
!***********************************************************************
SUBROUTINE SXINMC(MM,NT,C,MI)

  IMPLICIT NONE
  INTEGER(8) :: MM,NT,M,IS,MI
  INTEGER(8) :: N1,M1,MN,NS,K
!!$  REAL(8) :: C((2*NT-MM+1)*(MM+1))
  REAL(8) :: C((MM/MI+1)*(2*(NT+1)-MM/MI*MI))
  INTEGER(8) :: NPMAX

  CALL MXGOMP(NPMAX)  

  N1=MM/MI+1
  M1=N1*MI
  MN=N1
  IF(MM/MI-M1/MI.GE.0) THEN
     MN=MN+1
  END IF

  !$omp parallel private(NS,M) num_threads(NPMAX)
  !$omp do schedule(dynamic)
  DO K=0,MN-1
     M=K*MI
     NS=K*(2*(NT+1)-(K-1)*MI)+1
     CALL LXINIC(NT,M,C(NS))
  END DO
  !$omp end do
  !$omp end parallel

END SUBROUTINE SXINMC
